diff --git a/rtemsbsd/include/rtems/bsd/local/vnode_if_newproto.h b/rtemsbsd/include/rtems/bsd/local/vnode_if_newproto.h
new file mode 100644
index 00000000..b2e2deba
--- /dev/null
+++ b/rtemsbsd/include/rtems/bsd/local/vnode_if_newproto.h
@@ -0,0 +1,84 @@
+/*
+ * This file is produced automatically.
+ * Do not modify anything in here by hand.
+ *
+ * Created from $FreeBSD$
+ */
+
+
+struct vop_vector {
+	struct vop_vector	*vop_default;
+	vop_bypass_t	*vop_bypass;
+	vop_islocked_t	*vop_islocked;
+	vop_lookup_t	*vop_lookup;
+	vop_cachedlookup_t	*vop_cachedlookup;
+	vop_create_t	*vop_create;
+	vop_whiteout_t	*vop_whiteout;
+	vop_mknod_t	*vop_mknod;
+	vop_open_t	*vop_open;
+	vop_close_t	*vop_close;
+	vop_access_t	*vop_access;
+	vop_accessx_t	*vop_accessx;
+	vop_getattr_t	*vop_getattr;
+	vop_setattr_t	*vop_setattr;
+	vop_markatime_t	*vop_markatime;
+	vop_read_t	*vop_read;
+	vop_write_t	*vop_write;
+	vop_ioctl_t	*vop_ioctl;
+	vop_poll_t	*vop_poll;
+	vop_kqfilter_t	*vop_kqfilter;
+	vop_revoke_t	*vop_revoke;
+	vop_fsync_t	*vop_fsync;
+	vop_remove_t	*vop_remove;
+	vop_link_t	*vop_link;
+	vop_rename_t	*vop_rename;
+	vop_mkdir_t	*vop_mkdir;
+	vop_rmdir_t	*vop_rmdir;
+	vop_symlink_t	*vop_symlink;
+	vop_readdir_t	*vop_readdir;
+	vop_readlink_t	*vop_readlink;
+	vop_inactive_t	*vop_inactive;
+	vop_reclaim_t	*vop_reclaim;
+	vop_lock1_t	*vop_lock1;
+	vop_unlock_t	*vop_unlock;
+	vop_bmap_t	*vop_bmap;
+	vop_strategy_t	*vop_strategy;
+	vop_getwritemount_t	*vop_getwritemount;
+	vop_print_t	*vop_print;
+	vop_pathconf_t	*vop_pathconf;
+	vop_advlock_t	*vop_advlock;
+	vop_advlockasync_t	*vop_advlockasync;
+	vop_advlockpurge_t	*vop_advlockpurge;
+	vop_reallocblks_t	*vop_reallocblks;
+	vop_getpages_t	*vop_getpages;
+	vop_getpages_async_t	*vop_getpages_async;
+	vop_putpages_t	*vop_putpages;
+	vop_getacl_t	*vop_getacl;
+	vop_setacl_t	*vop_setacl;
+	vop_aclcheck_t	*vop_aclcheck;
+	vop_closeextattr_t	*vop_closeextattr;
+	vop_getextattr_t	*vop_getextattr;
+	vop_listextattr_t	*vop_listextattr;
+	vop_openextattr_t	*vop_openextattr;
+	vop_deleteextattr_t	*vop_deleteextattr;
+	vop_setextattr_t	*vop_setextattr;
+	vop_setlabel_t	*vop_setlabel;
+	vop_vptofh_t	*vop_vptofh;
+	vop_vptocnp_t	*vop_vptocnp;
+	vop_allocate_t	*vop_allocate;
+	vop_advise_t	*vop_advise;
+	vop_unp_bind_t	*vop_unp_bind;
+	vop_unp_connect_t	*vop_unp_connect;
+	vop_unp_detach_t	*vop_unp_detach;
+	vop_is_text_t	*vop_is_text;
+	vop_set_text_t	*vop_set_text;
+	vop_unset_text_t	*vop_unset_text;
+	vop_get_writecount_t	*vop_get_writecount;
+	vop_add_writecount_t	*vop_add_writecount;
+	vop_fdatasync_t	*vop_fdatasync;
+	vop_spare1_t	*vop_spare1;
+	vop_spare2_t	*vop_spare2;
+	vop_spare3_t	*vop_spare3;
+	vop_spare4_t	*vop_spare4;
+	vop_spare5_t	*vop_spare5;
+};
diff --git a/rtemsbsd/include/rtems/bsd/local/vnode_if_typedef.h b/rtemsbsd/include/rtems/bsd/local/vnode_if_typedef.h
new file mode 100644
index 00000000..22204a1f
--- /dev/null
+++ b/rtemsbsd/include/rtems/bsd/local/vnode_if_typedef.h
@@ -0,0 +1,224 @@
+/*
+ * This file is produced automatically.
+ * Do not modify anything in here by hand.
+ *
+ * Created from $FreeBSD$
+ */
+
+
+struct vop_islocked_args;
+typedef int vop_islocked_t(struct vop_islocked_args *);
+
+struct vop_lookup_args;
+typedef int vop_lookup_t(struct vop_lookup_args *);
+
+struct vop_cachedlookup_args;
+typedef int vop_cachedlookup_t(struct vop_cachedlookup_args *);
+
+struct vop_create_args;
+typedef int vop_create_t(struct vop_create_args *);
+
+struct vop_whiteout_args;
+typedef int vop_whiteout_t(struct vop_whiteout_args *);
+
+struct vop_mknod_args;
+typedef int vop_mknod_t(struct vop_mknod_args *);
+
+struct vop_open_args;
+typedef int vop_open_t(struct vop_open_args *);
+
+struct vop_close_args;
+typedef int vop_close_t(struct vop_close_args *);
+
+struct vop_access_args;
+typedef int vop_access_t(struct vop_access_args *);
+
+struct vop_accessx_args;
+typedef int vop_accessx_t(struct vop_accessx_args *);
+
+struct vop_getattr_args;
+typedef int vop_getattr_t(struct vop_getattr_args *);
+
+struct vop_setattr_args;
+typedef int vop_setattr_t(struct vop_setattr_args *);
+
+struct vop_markatime_args;
+typedef int vop_markatime_t(struct vop_markatime_args *);
+
+struct vop_read_args;
+typedef int vop_read_t(struct vop_read_args *);
+
+struct vop_write_args;
+typedef int vop_write_t(struct vop_write_args *);
+
+struct vop_ioctl_args;
+typedef int vop_ioctl_t(struct vop_ioctl_args *);
+
+struct vop_poll_args;
+typedef int vop_poll_t(struct vop_poll_args *);
+
+struct vop_kqfilter_args;
+typedef int vop_kqfilter_t(struct vop_kqfilter_args *);
+
+struct vop_revoke_args;
+typedef int vop_revoke_t(struct vop_revoke_args *);
+
+struct vop_fsync_args;
+typedef int vop_fsync_t(struct vop_fsync_args *);
+
+struct vop_remove_args;
+typedef int vop_remove_t(struct vop_remove_args *);
+
+struct vop_link_args;
+typedef int vop_link_t(struct vop_link_args *);
+
+struct vop_rename_args;
+typedef int vop_rename_t(struct vop_rename_args *);
+
+struct vop_mkdir_args;
+typedef int vop_mkdir_t(struct vop_mkdir_args *);
+
+struct vop_rmdir_args;
+typedef int vop_rmdir_t(struct vop_rmdir_args *);
+
+struct vop_symlink_args;
+typedef int vop_symlink_t(struct vop_symlink_args *);
+
+struct vop_readdir_args;
+typedef int vop_readdir_t(struct vop_readdir_args *);
+
+struct vop_readlink_args;
+typedef int vop_readlink_t(struct vop_readlink_args *);
+
+struct vop_inactive_args;
+typedef int vop_inactive_t(struct vop_inactive_args *);
+
+struct vop_reclaim_args;
+typedef int vop_reclaim_t(struct vop_reclaim_args *);
+
+struct vop_lock1_args;
+typedef int vop_lock1_t(struct vop_lock1_args *);
+
+struct vop_unlock_args;
+typedef int vop_unlock_t(struct vop_unlock_args *);
+
+struct vop_bmap_args;
+typedef int vop_bmap_t(struct vop_bmap_args *);
+
+struct vop_strategy_args;
+typedef int vop_strategy_t(struct vop_strategy_args *);
+
+struct vop_getwritemount_args;
+typedef int vop_getwritemount_t(struct vop_getwritemount_args *);
+
+struct vop_print_args;
+typedef int vop_print_t(struct vop_print_args *);
+
+struct vop_pathconf_args;
+typedef int vop_pathconf_t(struct vop_pathconf_args *);
+
+struct vop_advlock_args;
+typedef int vop_advlock_t(struct vop_advlock_args *);
+
+struct vop_advlockasync_args;
+typedef int vop_advlockasync_t(struct vop_advlockasync_args *);
+
+struct vop_advlockpurge_args;
+typedef int vop_advlockpurge_t(struct vop_advlockpurge_args *);
+
+struct vop_reallocblks_args;
+typedef int vop_reallocblks_t(struct vop_reallocblks_args *);
+
+struct vop_getpages_args;
+typedef int vop_getpages_t(struct vop_getpages_args *);
+
+struct vop_getpages_async_args;
+typedef int vop_getpages_async_t(struct vop_getpages_async_args *);
+
+struct vop_putpages_args;
+typedef int vop_putpages_t(struct vop_putpages_args *);
+
+struct vop_getacl_args;
+typedef int vop_getacl_t(struct vop_getacl_args *);
+
+struct vop_setacl_args;
+typedef int vop_setacl_t(struct vop_setacl_args *);
+
+struct vop_aclcheck_args;
+typedef int vop_aclcheck_t(struct vop_aclcheck_args *);
+
+struct vop_closeextattr_args;
+typedef int vop_closeextattr_t(struct vop_closeextattr_args *);
+
+struct vop_getextattr_args;
+typedef int vop_getextattr_t(struct vop_getextattr_args *);
+
+struct vop_listextattr_args;
+typedef int vop_listextattr_t(struct vop_listextattr_args *);
+
+struct vop_openextattr_args;
+typedef int vop_openextattr_t(struct vop_openextattr_args *);
+
+struct vop_deleteextattr_args;
+typedef int vop_deleteextattr_t(struct vop_deleteextattr_args *);
+
+struct vop_setextattr_args;
+typedef int vop_setextattr_t(struct vop_setextattr_args *);
+
+struct vop_setlabel_args;
+typedef int vop_setlabel_t(struct vop_setlabel_args *);
+
+struct vop_vptofh_args;
+typedef int vop_vptofh_t(struct vop_vptofh_args *);
+
+struct vop_vptocnp_args;
+typedef int vop_vptocnp_t(struct vop_vptocnp_args *);
+
+struct vop_allocate_args;
+typedef int vop_allocate_t(struct vop_allocate_args *);
+
+struct vop_advise_args;
+typedef int vop_advise_t(struct vop_advise_args *);
+
+struct vop_unp_bind_args;
+typedef int vop_unp_bind_t(struct vop_unp_bind_args *);
+
+struct vop_unp_connect_args;
+typedef int vop_unp_connect_t(struct vop_unp_connect_args *);
+
+struct vop_unp_detach_args;
+typedef int vop_unp_detach_t(struct vop_unp_detach_args *);
+
+struct vop_is_text_args;
+typedef int vop_is_text_t(struct vop_is_text_args *);
+
+struct vop_set_text_args;
+typedef int vop_set_text_t(struct vop_set_text_args *);
+
+struct vop_unset_text_args;
+typedef int vop_unset_text_t(struct vop_unset_text_args *);
+
+struct vop_get_writecount_args;
+typedef int vop_get_writecount_t(struct vop_get_writecount_args *);
+
+struct vop_add_writecount_args;
+typedef int vop_add_writecount_t(struct vop_add_writecount_args *);
+
+struct vop_fdatasync_args;
+typedef int vop_fdatasync_t(struct vop_fdatasync_args *);
+
+struct vop_spare1_args;
+typedef int vop_spare1_t(struct vop_spare1_args *);
+
+struct vop_spare2_args;
+typedef int vop_spare2_t(struct vop_spare2_args *);
+
+struct vop_spare3_args;
+typedef int vop_spare3_t(struct vop_spare3_args *);
+
+struct vop_spare4_args;
+typedef int vop_spare4_t(struct vop_spare4_args *);
+
+struct vop_spare5_args;
+typedef int vop_spare5_t(struct vop_spare5_args *);
+
diff --git a/rtemsbsd/include/rtems/bsd/rootfs.h b/rtemsbsd/include/rtems/bsd/rootfs.h
new file mode 100644
index 00000000..b2768c31
--- /dev/null
+++ b/rtemsbsd/include/rtems/bsd/rootfs.h
@@ -0,0 +1,51 @@
+/**
+ * @file
+ *
+ * @ingroup rtems_bsd
+ *
+ * @brief TODO.
+ */
+
+/*
+ * Copyright (c) 20206 Chris Johns.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#ifndef _RTEMS_BSD_ROOTFS_H_
+#define _RTEMS_BSD_ROOTFS_H_
+
+#ifdef __cplusplus
+extern "C" {
+#endif /* __cplusplus */
+
+/*
+ * Short cut to creating a directory in the root file system.
+ */
+int rtems_bsd_rootfs_mkdir(const char *name);
+int rtems_bsd_rootfs_rmdir(const char *name);
+
+#ifdef __cplusplus
+}
+#endif /* __cplusplus */
+
+#endif /* _RTEMS_BSD_ROOTFS_H_ */
diff --git a/rtemsbsd/include/vm/vm_object.h b/rtemsbsd/include/vm/vm_object.h
index 936ffd88..9707a0c6 100644
--- a/rtemsbsd/include/vm/vm_object.h
+++ b/rtemsbsd/include/vm/vm_object.h
@@ -1 +1,16 @@
-/* EMPTY */
+#ifndef RTEMS_VM_OBJCT_H
+#define RTEMS_VM_OBJCT_H
+
+/*
+ * Helpers to perform conversion between vm_object page indexes and offsets.
+ * IDX_TO_OFF() converts an index into an offset.
+ * OFF_TO_IDX() converts an offset into an index.
+ * OBJ_MAX_SIZE specifies the maximum page index corresponding to the
+ *   maximum unsigned offset.
+ */
+#define IDX_TO_OFF(idx) (((vm_ooffset_t)(idx)) << PAGE_SHIFT)
+#define OFF_TO_IDX(off) ((vm_pindex_t)(((vm_ooffset_t)(off)) >> PAGE_SHIFT))
+#define UOFF_TO_IDX(off) OFF_TO_IDX(off)
+#define OBJ_MAX_SIZE    (OFF_TO_IDX(UINT64_MAX) + 1)
+
+#endif
diff --git a/rtemsbsd/include/vm/vm_pager.h b/rtemsbsd/include/vm/vm_pager.h
index e69de29b..d9bc1524 100644
--- a/rtemsbsd/include/vm/vm_pager.h
+++ b/rtemsbsd/include/vm/vm_pager.h
@@ -0,0 +1,20 @@
+#ifndef RTEMS_VM_PAGER_H
+#define RTEMS_VM_PAGER_H
+
+/*
+ * get/put return values
+ * OK    operation was successful
+ * BAD   specified data was out of the accepted range
+ * FAIL  specified data was in range, but doesn't exist
+ * PEND  operations was initiated but not completed
+ * ERROR error while accessing data that is in range and exists
+ * AGAIN temporary resource shortage prevented operation from happening
+ */
+#define VM_PAGER_OK     0
+#define VM_PAGER_BAD    1
+#define VM_PAGER_FAIL   2
+#define VM_PAGER_PEND   3
+#define VM_PAGER_ERROR  4
+#define VM_PAGER_AGAIN  5
+
+#endif
diff --git a/rtemsbsd/rtems/rtems-bsd-allocator-domain-size.c b/rtemsbsd/rtems/rtems-bsd-allocator-domain-size.c
index 089ba747..771bca73 100644
--- a/rtemsbsd/rtems/rtems-bsd-allocator-domain-size.c
+++ b/rtemsbsd/rtems/rtems-bsd-allocator-domain-size.c
@@ -41,3 +41,4 @@
 #include <rtems/bsd/bsd.h>
 
 uintptr_t rtems_bsd_allocator_domain_page_mbuf_size = RTEMS_BSD_ALLOCATOR_DOMAIN_PAGE_MBUF_DEFAULT;
+uintptr_t rtems_bsd_allocator_domain_bio_size = RTEMS_BSD_ALLOCATOR_DOMAIN_BIO_DEFAULT;
diff --git a/rtemsbsd/rtems/rtems-bsd-get-allocator-domain-size.c b/rtemsbsd/rtems/rtems-bsd-get-allocator-domain-size.c
index d94a719b..590c3386 100644
--- a/rtemsbsd/rtems/rtems-bsd-get-allocator-domain-size.c
+++ b/rtemsbsd/rtems/rtems-bsd-get-allocator-domain-size.c
@@ -49,6 +49,9 @@ rtems_bsd_get_allocator_domain_size(rtems_bsd_allocator_domain domain)
 		case RTEMS_BSD_ALLOCATOR_DOMAIN_MBUF:
 			size = rtems_bsd_allocator_domain_page_mbuf_size;
 			break;
+		case RTEMS_BSD_ALLOCATOR_DOMAIN_BIO:
+			size = rtems_bsd_allocator_domain_bio_size;
+			break;
 		default:
 			size = 0;
 			break;
diff --git a/rtemsbsd/rtems/rtems-bsd-libio.c b/rtemsbsd/rtems/rtems-bsd-libio.c
new file mode 100644
index 00000000..5736a001
--- /dev/null
+++ b/rtemsbsd/rtems/rtems-bsd-libio.c
@@ -0,0 +1,193 @@
+/**
+ * @file
+ *
+ * @ingroup rtems_bsd_rtems
+ *
+ * @brief TODO.
+ */
+
+/*
+ * Copyright 2020 Chris Johns. All Rights Reserved.
+ *
+ *  Contemporary Software
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY
+ * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+ * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+ * DISCLAIMED.  IN NO EVENT SHALL THE FREEBSD PROJECT BE LIABLE FOR
+ * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <machine/rtems-bsd-kernel-space.h>
+
+#include <sys/param.h>
+#include <sys/filedesc.h>
+#include <sys/proc.h>
+#include <sys/vnode.h>
+
+#include <rtems/libio.h>
+
+#include <machine/rtems-bsd-libio.h>
+
+rtems_libio_t *
+rtems_bsd_libio_iop_allocate(void)
+{
+	rtems_libio_t *iop = rtems_libio_allocate();
+	if (iop != NULL) {
+		iop->pathinfo.mt_entry = &rtems_filesystem_null_mt_entry;
+		rtems_filesystem_location_add_to_mt_entry(&iop->pathinfo);
+	}
+	return iop;
+}
+
+int
+rtems_bsd_libio_iop_allocate_with_file(
+    struct thread *td, int fd, const rtems_filesystem_file_handlers_r *ops)
+{
+	rtems_libio_t *iop = rtems_bsd_libio_iop_allocate();
+	int iofd = -1;
+	if (iop != NULL) {
+		int error = rtems_bsd_libio_iop_set_bsd_fd(td, fd, iop, ops);
+		/*
+		 * The fp is held and needs to be dropped and that drops the
+		 * iop.
+		 */
+		if (error == 0) {
+			rtems_libio_iop_hold(iop);
+			iofd = rtems_libio_iop_to_descriptor(iop);
+		} else {
+			rtems_libio_free(iop);
+		}
+	}
+	return iofd;
+}
+
+int
+rtems_bsd_libio_iop_set_bsd_fd(struct thread *td, int fd, rtems_libio_t *iop,
+    const rtems_filesystem_file_handlers_r *ops)
+{
+	struct filedesc *fdp = td->td_proc->p_fd;
+	int error;
+	FILEDESC_XLOCK(fdp);
+	if (fd < fdp->fd_nfiles) {
+		struct file *fp = fget_locked(fdp, fd);
+		if (fp != NULL) {
+			rtems_bsd_libio_iop_set_bsd_file(iop, fp);
+			rtems_libio_iop_flags_set(iop,
+			    LIBIO_FLAGS_OPEN |
+				rtems_bsd_libio_fflag_to_flags(fp->f_flag));
+			if (ops != NULL)
+				iop->pathinfo.handlers = ops;
+			rtems_bsd_libio_iop_set_bsd_descriptor(iop, fd);
+			error = 0;
+		} else {
+			error = EBADF;
+		}
+	} else {
+		error = EBADF;
+	}
+	FILEDESC_XUNLOCK(fdp);
+	return error;
+}
+
+void
+rtems_bsd_libio_loc_set_vnode(
+    rtems_filesystem_location_info_t *loc, struct vnode *vp)
+{
+	struct vnode *old = loc->node_access;
+	int hc = 0;
+	int rc = 0;
+	if (vp != NULL) {
+		hc = vp->v_holdcnt;
+		rc = vrefcnt(vp);
+	}
+	int old_hc = 0;
+	int old_rc = 0;
+	if (old != NULL) {
+		old_hc = old->v_holdcnt;
+		old_rc = vrefcnt(old);
+	}
+	if (vp != old) {
+		if (old != NULL)
+			vrele(old);
+		if (vp != NULL)
+			VREF(vp);
+		loc->node_access = vp;
+	}
+	int new_hc = 0;
+	int new_rc = 0;
+	if (vp != NULL) {
+		new_hc = vp->v_holdcnt;
+		new_rc = vrefcnt(vp);
+	}
+	int old_new_hc = 0;
+	int old_new_rc = 0;
+	if (old != NULL) {
+		old_new_hc = old->v_holdcnt;
+		old_new_rc = vrefcnt(old);
+	}
+	if (RTEMS_BSD_DESCRIP_TRACE || true)
+		printf(
+		    "bsd: lio: set-vode loc=%p vn=%p (%d/%d)->(%d/%d) old=%p (%d/%d)->(%d/%d)\n",
+		    loc, vp, hc, rc, new_hc, new_rc, old, old_hc, old_rc,
+		    old_new_hc, old_new_rc);
+}
+
+void
+rtems_bsd_libio_loc_set_vnode_dir(
+    rtems_filesystem_location_info_t *loc, struct vnode *dvp)
+{
+	struct vnode *old = loc->node_access_2;
+	int hc = 0;
+	int rc = 0;
+	if (dvp != NULL) {
+		hc = dvp->v_holdcnt;
+		rc = vrefcnt(dvp);
+	}
+	int old_hc = 0;
+	int old_rc = 0;
+	if (old != NULL) {
+		old_hc = old->v_holdcnt;
+		old_rc = vrefcnt(old);
+	}
+	if (dvp != old) {
+		if (old != NULL)
+			vrele(old);
+		if (dvp != NULL)
+			VREF(dvp);
+		loc->node_access_2 = dvp;
+	}
+	int new_hc = 0;
+	int new_rc = 0;
+	if (dvp != NULL) {
+		new_hc = dvp->v_holdcnt;
+		new_rc = vrefcnt(dvp);
+	}
+	int old_new_hc = 0;
+	int old_new_rc = 0;
+	if (old != NULL) {
+		old_new_hc = old->v_holdcnt;
+		old_new_rc = vrefcnt(old);
+	}
+	if (RTEMS_BSD_DESCRIP_TRACE || true)
+		printf(
+		    "bsd: lio: set-vode-dir loc=%p vn=%p (%d/%d)->(%d/%d) old=%p (%d/%d)->(%d/%d)\n",
+		    loc, dvp, hc, rc, new_hc, new_rc, old, old_hc, old_rc,
+		    old_new_hc, old_new_rc);
+}
diff --git a/rtemsbsd/rtems/rtems-bsd-mountroot.c b/rtemsbsd/rtems/rtems-bsd-mountroot.c
new file mode 100644
index 00000000..132a08ff
--- /dev/null
+++ b/rtemsbsd/rtems/rtems-bsd-mountroot.c
@@ -0,0 +1,124 @@
+/* SPDX-License-Identifier: BSD-2-Clause */
+
+/**
+ * @file
+ *
+ * @ingroup FileSystems
+ *
+ * @brief Mount a root file system.
+ */
+
+/*
+ * Copyright (C) 2020 Chris Johns <chris@contemporary.software>
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <machine/rtems-bsd-kernel-space.h>
+
+#include <sys/types.h>
+#include <sys/param.h>
+#include <sys/filedesc.h>
+#include <sys/kernel.h>
+#include <sys/mount.h>
+#include <sys/resourcevar.h>
+#include <sys/vnode.h>
+
+#include <vm/vm_extern.h>
+
+struct vnode *rootvnode;
+
+MALLOC_DECLARE(M_MOUNT);
+
+static void
+set_rootvnode(struct mount *mp)
+{
+	struct proc *p;
+	int error;
+
+	error = VFS_ROOT(mp, LK_EXCLUSIVE, &rootvnode);
+	if (error != 0)
+		panic("Cannot find root vnode");
+
+	VOP_UNLOCK(rootvnode, 0);
+
+	p = curthread->td_proc;
+	FILEDESC_XLOCK(p->p_fd);
+
+	if (p->p_fd->fd_cdir != NULL)
+		vrele(p->p_fd->fd_cdir);
+	p->p_fd->fd_cdir = rootvnode;
+	VREF(rootvnode);
+
+	if (p->p_fd->fd_rdir != NULL)
+		vrele(p->p_fd->fd_rdir);
+	p->p_fd->fd_rdir = rootvnode;
+	VREF(rootvnode);
+
+	FILEDESC_XUNLOCK(p->p_fd);
+}
+
+static void
+bsd_mountroot(const char *fstype)
+{
+	struct vfsoptlist *opts;
+	struct vfsconf *vfsp;
+	struct mount *mp;
+	struct ucred *cred;
+	int error;
+
+	cred = crget();
+	cred->cr_uidinfo = uifind(0);
+	cred->cr_ruidinfo = uifind(0);
+
+	vfsp = vfs_byname(fstype);
+	if (vfsp != NULL) {
+		mp = vfs_mount_alloc(NULLVP, vfsp, "/", cred);
+
+		crfree(cred);
+
+		error = VFS_MOUNT(mp);
+		if (error != 0)
+			panic("Cannot mount root file system: %d", error);
+
+		error = VFS_STATFS(mp, &mp->mnt_stat);
+		if (error != 0)
+			panic("Cannot stat root file system: %d", error);
+
+		opts = malloc(sizeof(struct vfsoptlist), M_MOUNT, M_WAITOK);
+		TAILQ_INIT(opts);
+		mp->mnt_opt = opts;
+
+		mtx_lock(&mountlist_mtx);
+		TAILQ_INSERT_HEAD(&mountlist, mp, mnt_list);
+		mtx_unlock(&mountlist_mtx);
+
+		set_rootvnode(mp);
+	}
+}
+
+static void
+bsd_rootfs_init(const void *dummy)
+{
+	bsd_mountroot("rootfs");
+}
+SYSINIT(bsdroot, SI_SUB_KTHREAD_INIT, SI_ORDER_FIRST, bsd_rootfs_init, NULL);
diff --git a/rtemsbsd/rtems/rtems-bsd-syscall-api.c b/rtemsbsd/rtems/rtems-bsd-syscall-api.c
index 63274a0e..defa1eb6 100644
--- a/rtemsbsd/rtems/rtems-bsd-syscall-api.c
+++ b/rtemsbsd/rtems/rtems-bsd-syscall-api.c
@@ -1,26 +1,32 @@
-/*
- * Copyright (c) 2013 embedded brains GmbH.  All rights reserved.
+/**
+ * @file
+ *
+ * @ingroup rtems_bsd_rtems
  *
- *  embedded brains GmbH
- *  Dornierstr. 4
- *  82178 Puchheim
- *  Germany
- *  <rtems@embedded-brains.de>
+ * @brief TODO.
+ *
+ * File origin from FreeBSD 'lib/libc/gen/sysctlnametomib.c'.
+ */
+
+/*
+ * Copyright 2001 The FreeBSD Project. All Rights Reserved.
+ * Copyright 2020 Chris Johns
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
+ *
  * 1. Redistributions of source code must retain the above copyright
  *    notice, this list of conditions and the following disclaimer.
  * 2. Redistributions in binary form must reproduce the above copyright
  *    notice, this list of conditions and the following disclaimer in the
  *    documentation and/or other materials provided with the distribution.
  *
- * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
- * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY
+ * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+ * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+ * DISCLAIMED.  IN NO EVENT SHALL THE FREEBSD PROJECT BE LIABLE FOR
+ * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
